using Components.Exceptions;

namespace WinFormsApp
{
    public partial class FormVisual : Form
    {
        public FormVisual()
        {
            InitializeComponent();
        }

        private void buttonFillCheckedList_Click(object sender, EventArgs e)
        {
            List<string> list = new List<string>();
            list.Add("");
            list.Add("");
            list.Add("");
            list.Add("");
            list.Add("C#");
            userControlCheckedList.SetCheckedListBoxValues(list);

            userControlCheckedList.CheckedItem = list[3];
        }

        private void buttonClearList_Click(object sender, EventArgs e)
        {
            userControlCheckedList.ClearCheckedListBoxValues();
        }

        private void buttonFillTreeView_Click(object sender, EventArgs e)
        {
            List<Employee> employees = new List<Employee>();
            employees.Add(new Employee(" ", "", "", ""));
            employees.Add(new Employee(" ", "", "", ""));
            employees.Add(new Employee(" ", "", "", ""));
            employees.Add(new Employee(" ", "", "", ""));

            employees.Add(new Employee(" ", "", "", ""));
            employees.Add(new Employee(" ", "", "", ""));
            employees.Add(new Employee(" ", "", "", ""));
            employees.Add(new Employee(" ", " ", "", ""));

            employees.Add(new Employee(" ", " ", "", ""));
            employees.Add(new Employee(" ", "PR-", "", ""));
            employees.Add(new Employee(" ", "", "", ""));
            employees.Add(new Employee(" ", "", "", ""));

            List<(string PropertyName, bool AlwaysCreateBranch)> hierarchy =
            [
                ("Id", false),
                ("Departament", false),
                ("Position", false),
                ("Surname", false),
                ("Name", false),
            ];

            userControlTreeView.SetHierarchy(hierarchy);

            userControlTreeView.SetTreeObjects(employees);
        }

        private void buttonClearTreeView_Click(object sender, EventArgs e)
        {
            userControlTreeView.ClearTreeView();
        }

        private void buttonShowTreeViewNode_Click(object sender, EventArgs e)
        {
            Employee employee;
            try
            {
                employee = userControlTreeView.GetObjectSelectedNode<Employee>();
                textBoxTreeViewSelectedObject.Text = employee.ToString();
            }
            catch (PropertyNotDeclaratedException ex)
            {
                MessageBox.Show(ex.Message);
                textBoxTreeViewSelectedObject.Text = string.Empty;
            }
            catch (PropertyNullException ex)
            {
                MessageBox.Show(ex.Message);
                textBoxTreeViewSelectedObject.Text = string.Empty;
            }
            catch (NotSelectedNodeException ex)
            {
                MessageBox.Show(ex.Message);
                textBoxTreeViewSelectedObject.Text = string.Empty;
            }
        }
    }
}
